# velociraptor.spec for stable upstream Fedora package
%global upstream_version 0.73.4
%global commit 3418df2246bb09316ad14cc39af24ffe1c37e614
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global debug_package %{nil}

Name:           velociraptor
Version:        %{upstream_version}
Release:        1%{?dist}
Summary:        Velociraptor - Endpoint visibility and collection tool.
License:        AGPL-3.0-only
URL:            https://github.com/Velocidex/velociraptor
Source0:        %{url}/archive/%{commit}/%{name}-%{shortcommit}.tar.gz

BuildRequires:  gcc
BuildRequires:  git-core
BuildRequires:  glibc-devel
BuildRequires:  golang-bin >= 1.23
BuildRequires:  libstdc++-static

%description
Velociraptor is a tool for collecting host based state information using The Velociraptor Query Language (VQL) queries.

%prep
%setup -q -n %{name}-%{commit}

%build
echo "current env: "
env
echo "now fix path"
# ensure fileb0x and gcc are in PATH
export PATH="$PATH:$(go env GOPATH)/bin"
echo "gcc path is: "
which gcc
echo "PATH is now $PATH"

# modify make command per architecture
%ifarch %{ix86} x86_64
make linux
%elifarch aarch64
make linux_arm64
%else
echo "Unsupported architecture: %{_arch}" >&2
exit 1
%endif

# instALL the things!
%install
install -m 0755 -vd %{buildroot}%{_bindir}
install -m 0755 -vd %{buildroot}%{_defaultdocdir}/velociraptor/third-party
install -m 0755 -vd %{buildroot}%{_defaultlicensedir}/velociraptor/third-party

install -m 0644 -vp %{_builddir}/velociraptor-%{commit}/README.md %{buildroot}%{_defaultdocdir}/velociraptor/README
install -m 0644 -vp %{_builddir}/velociraptor-%{commit}/third_party/zip/README.md %{buildroot}%{_defaultdocdir}/velociraptor/third-party/README-zip
install -m 0644 -vp %{_builddir}/velociraptor-%{commit}/LICENSE %{buildroot}%{_defaultlicensedir}/velociraptor/LICENSE
install -m 0644 -vp %{_builddir}/velociraptor-%{commit}/third_party/zip/LICENSE %{buildroot}%{_defaultlicensedir}/velociraptor/third-party/LICENSE-zip
install -m 0755 -vp %{_builddir}/velociraptor-%{commit}/output/velociraptor-v%{version}* %{buildroot}%{_bindir}/velociraptor

%files
%license %{_defaultlicensedir}/velociraptor/LICENSE
%license %{_defaultlicensedir}/velociraptor/third-party/LICENSE-zip
%doc docs
%doc %{_defaultdocdir}/velociraptor/README
%doc %{_defaultdocdir}/velociraptor/third-party/README-zip
%doc debian/changelog
%doc vql/windows/wmi/parse/fixtures/sample.txt
%{_bindir}/*

%changelog
* Mon Feb 24 2025 Upstream Packager <upstream@hyperkind.net> - 0.73.4-1
- Initial package (commit 3418df2)
